#!/bin/ch
/******************** 
 * Created 08/04/07
 ********************/
#include "compensate.h"

int main() {
  int t_time = 100, num;
  class CPlot plot;
  chstrarray name, value;
  char *plotWhat;
  CControl sys;

  Response.setContentType("image/png");
  Response.begin();

  num = Request.getFormNameValue(name, value);
  createModel(&sys, num, name, value);

  plotWhat = read1Str("plotWhat", num, name, value);

  sys.sgrid(0);

  plot.outputType(PLOT_OUTPUTTYPE_STREAM, "png");

  if(strcmp(plotWhat, "rlocus") == 0){
    sys.rlocus(&plot, NULL, NULL);
  }
  else if(strcmp(plotWhat, "Step") == 0) {
    array double yout[500];
    int np, nz;
    double oldk, k, tf;
    array double n[1] = {1}, d[1] = {1};
    CControl sys2, sys3, *sys4;

    np = sys.size('p');
    nz = sys.size('z');
    array double complex p[np], z[nz];

    sys.zpkdata(z, p, &oldk);
  
    tf = read1Value("TfValue", num, name, value);

    if(read1Str("Gain", num, name, value) != NULL) {
      k = read1Value("Gain", num, name, value);
      sys2.model("zpk", z, p, oldk*k);
      sys3.model("tf", n, d);
      sys4 = sys2.feedback(&sys3);
      sys4->grid(1);

      if(tf <= 0) {
        sys4->step(&plot, yout, NULL, NULL);
      }
      else {
        sys4->step(&plot, yout, NULL, NULL, tf*2);
      }
    }
    else {
      sys3.model("tf", n, d);
      sys4 = sys.feedback(&sys3);
      sys4->grid(1);

      if(tf <= 0) {
        sys4->step(&plot, yout, NULL, NULL);
      }
      else {
        sys4->step(&plot, yout, NULL, NULL, tf*2);
      }
    }
  }
  else if(strcmp(plotWhat, "Ramp") == 0) {
    int np, nz;
    double oldk, k, tf;
    array double n[1] = {1}, d[1] = {1};
    array double t[t_time];
    CControl sys2, sys3, *sys4;

    np = sys.size('p');
    nz = sys.size('z');
    array double complex p[np], z[nz];

    sys.zpkdata(z, p, &oldk);

    if(read1Str("Gain", num, name, value) != NULL) { 
      k = read1Value("Gain", num, name, value);
      sys2.model("zpk", z, p, oldk*k);
      sys3.model("tf", n, d);
      sys4 = sys2.feedback(&sys3);
      tf = read1Value("TfValue", num, name, value);

      if(tf <= 0) {
        linspace(t, 0, 20);
        sys4->grid(1);
        sys4->lsim(&plot, NULL, NULL, NULL, t, 20);
      }
      else {
        linspace(t, 0, tf);
        sys4->grid(1);
        sys4->lsim(&plot, NULL, NULL, NULL, t, tf*2);
      }
    }
    else {
      linspace(t, 0, 20);
      sys3.model("tf", n, d);
      sys4 = sys.feedback(&sys3);
      sys4->grid(1);
      sys4->lsim(&plot, NULL, NULL, NULL, t, 20);
    }
  }
  else if(strcmp(plotWhat, "Parabola") == 0) {
    int np, nz;
    double oldk, k, tf;
    array double n[1] = {1}, d[1] = {1};
    array double t[t_time];
    CControl sys2, sys3, *sys4;

    np = sys.size('p');
    nz = sys.size('z');
    array double complex p[np], z[nz];

    sys.zpkdata(z, p, &oldk);

    if(read1Str("Gain", num, name, value) != NULL) { 
      k = read1Value("Gain", num, name, value);
      sys2.model("zpk", z, p, oldk*k);
      sys3.model("tf", n, d);
      sys4 = sys2.feedback(&sys3);
      tf = read1Value("TfValue", num, name, value);

      if(tf <= 0) {
        linspace(t, 0, 20);
        t = t.*t;
        t = t/2;
        sys4->grid(1);
        sys4->lsim(&plot, NULL, NULL, NULL, t, 20);
      }
      else {
        linspace(t, 0, tf);
        t = t.*t;
        t = t/2;
        sys4->grid(1);
        sys4->lsim(&plot, NULL, NULL, NULL, t, tf*2);
      }
    }
    else {
      linspace(t, 0, 20);
      t = t.*t;
      t = t/2;
      sys3.model("tf", n, d);
      sys4 = sys.feedback(&sys3);
      sys4->grid(1);
      sys4->lsim(&plot, NULL, NULL, NULL, t, 20);
    }
  }
  Response.end();
  return 0;
}
